class CommentsController < ApplicationController
  before_filter :authenticate_user!

  def index

    if params[:filter] != nil
      y 'AQUIIIIIIII'
      @issues = Issue.find_by_problem_nature(params[:filter][:problem_nature_id]) if !params[:filter][:problem_nature_id].nil? and params[:filter][:problem_nature_id] != ''
      @problem_nature_id = params[:filter][:problem_nature_id]

      if !@issues.nil?
        @issues = @issues.find_by_status(params[:filter][:issue_status_id]) if !params[:filter][:issue_status_id].nil? and params[:filter][:issue_status_id] != ''
      else
        @issues = Issue.find_by_status(params[:filter][:issue_status_id]) if !params[:filter][:issue_status_id].nil? and params[:filter][:issue_status_id] != ''
      end
      @issue_status_id = params[:filter][:issue_status_id]

      if !@issues.nil?
        @issues.sort_by!{|issue| haversine_distance(issue.latitude, issue.longitude, current_user.latitude, current_user.longitude) } if !params[:filter][:order_by].nil? and params[:filter][:order_by] != ''
      else
        @issues = Issue.find(:all)
        @issues.sort_by!{|issue| haversine_distance(issue.latitude, issue.longitude, current_user.latitude, current_user.longitude) } if !params[:filter][:order_by].nil? and params[:filter][:order_by] != ''
      end
      @order_by = params[:filter][:order_by]
      @issues = @issues.paginate(:page => params[:page])
    else
      @issues = Issue.find(:all).paginate(:page => params[:page])
    end
    
    @followers = FollowIssue.count(:group => :followed_issue_id)
    @comments = Comment.count(:group => :issue_id)
    @problems_natures = ProblemsNature.find(:all)	

    # percorre a lista de issues toda vez. Ineficiente. Arrumar depois 
    @issues.each do |issue|
      issue.number_followers = 0
      @followers.each do |follower| 
        if issue.id == follower[0]
          issue.number_followers = follower[1]
          break
        end
      end
    end

    # mesma coisa aqui
    @issues.each do |issue|
      issue.number_comments = 0
      @comments.each do |comment|
        if issue.id == comment[0]
          issue.number_comments = comment[1]
        end
      end
    end

  end



  def show_issue
    @issue = Issue.find(params[:id])
    @followers = FollowIssue.where(:followed_issue_id => @issue.id)
    @disable_following = false
    if @issue.user_id == current_user.id
      @disable_following = true
    else
      @enable_unfollow = false
      @followers.each do |follower|
        if follower.followed_by_user_id == current_user.id
          @enable_unfollow = true
          break
        end
      end
    end

    @problemnature = ProblemsNature.find(@issue.problem_nature_id)
    @issuestatus = IssueStatus.find(@issue.issue_status_id)
    @comments = @issue.comments
    @pictures = @issue.pictures
    @comment = Comment.new
  end


  def create
    y params[:comment]
    @comment = Comment.new(params[:comment])
    
    respond_to do |format|
      if @comment.save
        format.html  { redirect_to(:action => "show_issue", :id => @comment.issue_id) }
      	format.json  { render :json => @comment,
                    		:status => :created, :location => @comment }
      else
      	format.html  { render :action => "show_issue" }
      	format.json  { render :json => @comment.errors,
                    		:status => :unprocessable_entity }
      end
    end
  end

  #ARRUMAR ISSO A URL DE REDIRECIONAMENTO TAH ERRADA
  def destroy
    @comment = Comment.find(params[:id])
    @comment.destroy
    
    respond_to do |format|
      format.html { redirect_to issue_comments_path(@issue) }
      format.json { head :no_content }
    end
  end

end
