package android.tcc;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Base64;
import android.widget.ImageView;

public class GaleryActivity extends Activity {

	private String pictureString;
	private Bitmap picture;
	private byte[] pictureBuffer;
	private ImageView pictureImage;
	
	public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
        setContentView(R.layout.galery);

        Bundle extras = getIntent().getExtras();
        if(extras != null) {
        	pictureString = (String) extras.get("picture");
        }
        pictureBuffer = Base64.decode(pictureString.getBytes(), Base64.DEFAULT);
        picture = BitmapFactory.decodeByteArray(pictureBuffer, 0, pictureBuffer.length);
        pictureImage = (ImageView) findViewById(R.id.GaleryPicture);
        pictureImage.setImageBitmap(picture);
        
	}
	
	
}
