class Admin::ProblemsNaturesController < ApplicationController
  before_filter :authenticate_user!, :is_admin?

  def index
    @problemsnatures = ProblemsNature.all
    @problemnature = ProblemsNature.new
    respond_to do |format|
      format.html  # index.html.erb
      format.json  { render :json => @problemsnatures }
    end
  end


  def create
    @problemnature = ProblemsNature.new(params[:problems_nature])
 
    respond_to do |format|
      if @problemnature.save
        format.html  { redirect_to(:action => "index",
                 		:notice => 'Problema was successfully created.') }
      	format.json  { render :json => @problemnature,
                    		:status => :created, :location => @problemnature }
      else
      	format.html  { render :action => "index" }
      	format.json  { render :json => @problemnature.errors,
                    		:status => :unprocessable_entity }
      end
    end
  end

  def destroy
    @problemsnature = ProblemsNature.find(params[:id])
    @problemsnature.destroy
	 
    respond_to do |format|
      format.html { redirect_to :action => "index" }
      format.json { head :no_content }
    end
  end

end
