class FollowIssueController < ApplicationController
  before_filter :authenticate_user!


  def create
    @follow_issue = FollowIssue.new
    logger.debug params[:id]
    @follow_issue.followed_issue_id = params[:id]
    @follow_issue.followed_by_user_id = current_user.id

    respond_to do |format|
      if @follow_issue.save
       format.html  { redirect_to(:back) }
       format.json  { render :json => @follow_issue, :status => :created, :location => @follow_issue }
      else
        format.html  { redirect_to(:back) }
        format.json  { render :json => @follow_issue.errors, :status => :unprocessable_entity }
      end
    end
  end

  def destroy
    @followed_issue = FollowIssue.find_by_followed_issue_id_and_followed_by_user_id(params[:id], current_user.id)

    if @followed_issue.destroy
      respond_to do |format|
        format.html { redirect_to(:back) }
        format.json { head :no_content }
      end
    end
  end

end
