class Comment < ActiveRecord::Base
  attr_accessible :user_id, :issue_id, :comment

  attr_accessor :owner_avatar
  attr_accessor :user_name

  belongs_to :issue
  belongs_to :user

    def as_json(resume = false)
      {
        :id => id,
        :user_id => user_id,
        :user_name => user_name,
        :issue_id => issue_id,
        :comment => comment,
        :owner_avatar => owner_avatar
      }
    end

end
