class CreateIssues < ActiveRecord::Migration
  def up
    create_table :issues do |t|
      t.integer :user_id, :null => false
      t.string :street
      t.integer :number
      t.string :neighborhood
      t.float :latitude
      t.float :longitude
      t.integer :problem_nature_id
      t.boolean :open, :default => true
      t.text :description, :null => false
      t.timestamps
    end
  end

  def down
    drop_table :issues
  end
end
